package xyz.veronie.bgg.result;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;

import org.eclipse.core.runtime.Path;

//import com.google.gson.Gson;

public enum ThingProvider {
	INSTANCE;
	
	/// list of things. Each ID is expected to exist exactly once.
	private List<Thing> things;
	
	private ThingProvider() {
		things = new ArrayList<Thing>();
	}
	
	/// replace current list with new list
	public void replaceThings(ArrayList<Thing> things) {
		this.things = things;
	}
	
	/// add things from argument to current list iff their ID does not exist yet
	public void addThings(ArrayList<Thing> things) {
		for(Thing tmd : things) {
			Boolean exists = false;
			for(Thing thisTmd : this.things) {
				if(tmd.getId() == thisTmd.getId()) {
					exists = true;
				}
			}
			if(!exists) {
				this.things.add(tmd);
			}
		}
	}
	
	
	// helper function for subtractThingMetas
	private static Predicate<Thing> thingEqual(final Thing other) 
	{
	    return p -> p.getId() == other.getId();
	}
	
	/// remove the things in the argument from the current list of things (using their ID)
	public void subtractThings(ArrayList<Thing> things) {
		for(Thing thing : things) {
			this.things.removeIf(thingEqual(thing));
		}
	}

	/// keep only things that exist in both argument list and current list (by ID)
	public void intersectThings(ArrayList<Thing> things) {
		List<Thing> cpThings = new ArrayList<Thing>(this.things);
		this.things.clear();
		for(Thing thing : things) {
			for(Thing thisThing : cpThings) {
				if(thing.getId() == thisThing.getId()) {
					this.things.add(thing);
				}
			}
		}
	}
	
	/// create a tag of the current list
	public void tagResult() {
//		Gson gson = new Gson();
//		String resultList = gson.toJson(this.thingMetas);
		
		try {
			Path filesPath = new Path("result_" + Long.toString(System.currentTimeMillis()));
			System.out.println("File output path: " + filesPath);
			BufferedWriter writer = new BufferedWriter(
				new FileWriter(filesPath.toString()));
//			writer.write(resultList);
			
		    writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	     
	}
	
	
	// return the current list of ids
	public List<Thing> getThings() {
        return things;
    }
	
//	@Inject
//	@Optional
//	private void subscribeTopicTagResult
//	    (@UIEventTopic(EventConstants.TOPIC_TAG_RESULT)
//	        String empty) {
//		System.out.println("TOPIC_TAG_RESULT: Tag result now.");
//		this.tagResult();
//	}
	
}
